/*
 *  Soccer Client Program main
 *    Ogalets the fourth
 *      presented by Ogawara
 */
#include "oga5a.h"

Socket init_connection(char* host, int port) ;
void   message_loop(FILE* fpin, FILE* fpout, Socket sock) ;
static int time_stamp=0;
int  s_flag=0,h_flag=0,b_flag=0,collision_flag=0;
int  list_flag=0;

extern Socket sock ;
extern double mx,my,mdir;
extern double bx,by;
extern int  player;
extern char side,cir_flag;
extern int  play_mode,time_counter;
extern int  mp_num,op_num;
extern char team_name[];
extern double flag_posi[10][2],goal_posi[2][2];
extern double off_posi[11][2];
extern double area_posi[11][2];

extern struct relative_address ball,flag[12],goal[2],line[4],mplayer[11],oplayer[11];
extern struct sequence_list s_list;

/* get relative angle */
double get_theta(double ox,double oy){
    double  odir;
	
    odir=get_angle(ox-mx,oy-my);
    odir-=mdir;
    if (odir<-180)
	odir+=360;
    else if (odir>180)
	odir-=360;
    return odir;
}

#define DETECT_ANGLE (20)

void pass(double *address,double *address2){
    double dist,ox=address[0],oy=address[1];
    double dir2,dir,odir;
    int  i,pow=0,k_flag=0;

    if (address2==NULL)
	address2=address;
    dist=get_dist(ox,oy,mx,my);
    dir=get_theta(ox,oy);
    if ((my>33.0) || (my<-33.0)){ /* around side line */
	if (my>33.0){
	    if ((mdir>0) && (mdir<90))
		k_flag=-1;
	    else if ((mdir>90) && (mdir<180))
		k_flag=1;
	} else{
	    if ((mdir>180) && (mdir<270))
		k_flag=-1;
	    else if ((mdir>270) && (mdir<360))
		k_flag=1;
	}
    }
    if (dir>120) /* kick back */
	k_flag=1;
    else if (dir<-120)
	k_flag=-1;
    if (k_flag!=0){
	kick(8,105*k_flag);
	usleep(20000);
	turn(90*k_flag);	    
	dir-=70*k_flag;
	usleep(210000);
    }
    if ((address[0]==goal_posi[1][0]) && (address[1]==goal_posi[1][1])) /* shoot */
	dist+=30.0;
    else if (k_flag==0){ /* enemy detection */
	dir2=get_theta(address2[0],address2[1]);
	if (dir==dir2)
	    k_flag=1;
	else if ((dir2<120) && (dir2>-120)){ /* check the other pass */
	    for (i=0;i<op_num;i++){
		if (oplayer[i].dist<20.0){
		    odir=oplayer[i].dir-dir2;
		    if ((odir>-DETECT_ANGLE) && (odir<DETECT_ANGLE))
			k_flag=1;
		}	
	    }
	} else
	    k_flag=1;
	for (i=0;i<op_num;i++){ /* check original pass */
	    if (oplayer[i].dist<20.0){
		odir=oplayer[i].dir-dir;
		if ((odir>-DETECT_ANGLE) && (odir<DETECT_ANGLE)){
		    if (!k_flag){
			dir=dir2;
		    } else{
			if (odir>0)
			    odir=DETECT_ANGLE-odir;
			else
			    odir=-DETECT_ANGLE-odir;
			dir-=odir;
		    }
		}
	    }
	}
    }
    kick((int)(dist*1.6)+20,dir);
}

void search_ball(void){
    int  dir;

    dir=ball.d[1];
    turn(dir);
}

#define DASH_RATIO (1.7)

/* go to relative position indicated by dist & odir */
void go(double dist,double odir){
    int  pow,i;
    static double tx=0.0,ty=0.0;
    static int f_count=0;

    if (get_dist(mx,my,tx,ty)<0.5){ /* collision check */
	if (++f_count>6){
	    i=random_num(2)*2-1;
	    turn(90.0*i);
	    list_flag=1;
	    s_list.count=1;
	    s_list.dist[1]=5.0; s_list.dir[1]=0.0;
	    s_list.dist[0]=0.0; s_list.dir[0]=-90.0*i;
	    f_count=0;
	    return;
	}
    } else
	f_count=0;
    if (abs_d(odir)>1.0){ /* turn */
	turn(odir);
    } else{ /* dash */
	if (dist>DASH_RATIO){
	    dash(100);
	    usleep(60000);
	    dist-=DASH_RATIO;
	}
	pow=(int)(dist*100.0/DASH_RATIO);
	dash(pow);
    }
    tx=mx; ty=my;
}

/* go to absolute position (ox,oy) */
void go_abs(double ox,double oy){
    double dist,odir;
	
    dist=get_dist(mx,my,ox,oy);
    odir=get_theta(ox,oy);
    go(dist,odir);
}

#define PREDICT_RATIO (1.5)
#define PREDICT_ANGLE (1.2)

/* go to ball using prediction */
void go_predict(void){
    double dist=ball.d[0],dir=ball.d[1];
    double ddist=ball.d[2],ddir=ball.d[3]*PI/180.0;
    double d,gamma;
    double t;
    int  i;

    if (ddir!=0.0){
	t=cos(ddir)-dist/(dist-ddist);
	gamma=atan(t/sin(ddir));
/*	gamma=atan((cos(ddir)-dist/(dist-ddist))/sin(ddir)); */
	if ((gamma*ddir>0.0) && (ddist>0.0)){ /* the ball is approaching to me */
	    printf("player %d gamma %lf ddir %lf t %lf\n",player,gamma,ddir,t);
	    d=dist*cos(gamma);
	    list_flag=1;
	    s_list.count=1;
	    i=(int)(d/DASH_RATIO)+1;
	    if (i>3) i=3;
	    while (i>1){
		s_list.dist[i]=DASH_RATIO; s_list.dir[i]=0.0;
		i--;
		d-=DASH_RATIO;
	    }
	    s_list.dist[1]=d; s_list.dir[1]=0.0;
	    s_list.dist[0]=0.0; s_list.dir[0]=90.0*((ddir>0.0) ? 1.0 : -1.0);
	    gamma=gamma*180.0/PI;
	} else{
	    gamma=0.0;
	    d=dist+ddist;
	}
    } else{
	gamma=0.0;
	d=dist+ddist;
    }
    go(dist,dir+gamma);
}

int  think(void){
    static int rotate_flag=0;
    int  i;
    char str[50];
    double dx,dy,dist,odir;

    if (s_flag!=1) return 0; /* see flag 1... get info this time,0... not yet */
    if (get_my_posi()==-1){ /* get my absolute position */
	turn(180); /* when lost */
	list_flag=1;
	s_list.count=0;
	s_list.dist[0]=DASH_RATIO; s_list.dir[0]=0.0;
	return 1;	
    }

    if (list_flag){ /* sequential list exists */
	i=s_list.count;
	go(s_list.dist[i],s_list.dir[i]);
	if (i==0)
	    list_flag=0;
	else
	    s_list.count--;
	return 1;
    }

    if (b_flag){ /* the ball is in sight */
	odir=mdir+ball.d[1];
	bx=mx+ball.d[0]*cos(odir/180.0*PI);
	by=my+ball.d[0]*sin(odir/180.0*PI);
	sprintf(str,"(say %s %d %3.1lf %3.1lf)\n",team_name,time_stamp+1,bx,by);
	rotate_flag=0; /* rotate_flag describes searching state */
    } else if (h_flag){
	ball.count=time_counter;
	ball.d[0]=get_dist(mx,my,bx,by);
	ball.d[1]=get_theta(bx,by);
	ball.d[2]=0.0;
	ball.d[3]=0.0;
	rotate_flag=0;
    }

    if (cir_flag){ /* cir_flag=1... go to my position,0... search ball */
	if ((ball.count==time_counter) && (ball.d[0]<15.0)){
	    go_predict();
	    cir_flag=0;
	} else if (get_dist(off_posi[player][0],off_posi[player][1],mx,my)>3.0){
	    go_abs(off_posi[player][0],off_posi[player][1]);
	} else{
	    cir_flag=0;
	    if ((b_flag) && (abs_d(ball.d[1])<1.0))
		send_message(str,sock);
	    else
		search_ball();
	}
    } else if (ball.count!=time_counter){ /* I can't see the ball, so search it */
	if (rotate_flag==0){
	    turn(-45.0);
	    rotate_flag=1;
	} else if (rotate_flag==1){
	    turn(90.0);
	    rotate_flag=2;
	} else{
	    turn(45.0);
	}
    } else if ((ball.dist>20.0)
	       && ((bx<off_posi[player][0]-area_posi[player][0])
		   || (bx>off_posi[player][0]+area_posi[player][0])
		   || (by<off_posi[player][1]-area_posi[player][1])
		   || (by>off_posi[player][1]+area_posi[player][1]))){
	if (get_dist(off_posi[player][0],off_posi[player][1],mx,my)>3.0){
	    go_abs(off_posi[player][0],off_posi[player][1]);		
	    cir_flag=1;
	} else{
	    if ((b_flag) && (abs_d(ball.d[1])<1.0))
		send_message(str,sock);
	    else
		search_ball();		
	}
    }else if (ball.dist>1.8){
	go_predict();
    } else{
	if ((my>20.0) || (my<-20.0)){
	    if (my>20.0) /* in the bottom area */
		i=0;
	    else /* in the top area */
		i=1;
	    
	    if (mx<-30.0)
		pass(off_posi[3+i],NULL);
	    else if (mx>41.0)
		pass(off_posi[2-i],NULL);
	    else if (mx>0.0)
		pass(goal_posi[1],NULL);		
	    else
		if (random_num(2)==0)
		    pass(off_posi[3+i],off_posi[4-i]);
		else
		    pass(off_posi[4-i],off_posi[3+i]);
	} else{
	    if (mx<-20.0)
		pass(off_posi[random_num(3)+3],off_posi[random_num(3)+3]);
	    else if (mx<10.0) 
		pass(off_posi[random_num(4)+1],off_posi[random_num(4)+1]);
	    else if (mx<25.0){
		if (my>0.0)
		    pass(off_posi[2],off_posi[1]);
		else
		    pass(off_posi[1],off_posi[2]);
	    } else if (mx<45.0)
		pass(goal_posi[1],NULL);
	    else if ((my>-10.0) && (my<10.0)){
		pass(goal_posi[1],NULL);
	    } else if (my>10.0)
		pass(off_posi[2],off_posi[1]);
	    else
		pass(off_posi[1],off_posi[2]);
	}
    }
    return 1;
}	
		
void see(char *buf){
    int  i;
    char *b_ptr=buf,name[100],*n_ptr;
    double odir;
    struct relative_address dummy,*dum_p;

    mp_num=0;
    op_num=0;
    if (player==19)
	printf("buf %s\n",buf);
    if (++time_counter==MAX_TIME_COUNTER)
	time_counter=0;
    do ++b_ptr;
    while((*b_ptr!='(') && (*b_ptr!=')'));
    if (*b_ptr==')')
	return;
    b_ptr+=2;
    while(1){
	switch(*b_ptr){
	  case 'l': /* line */
	    b_ptr+=5;
	    switch(*b_ptr){
	      case 'l': /* left end */
		i=0; break;
	      case 'r': /* right end */
		i=1; break;
	      case 't': /* top end */
		i=2; break;
	      case 'b': /* bottom end */
		i=3; break;
	    }
	    if (side!='l')
		i^=0x1;
	    b_ptr+=3;
	    b_ptr=get_para(&line[i],b_ptr);

	    if (line[i].d[1]>0.0)
		line[i].d[1]=90.0-line[i].d[1];
	    else
		line[i].d[1]=-90.0-line[i].d[1];
	    
	    break;

	  case 'p': /* player */
	    b_ptr+=6;
	    if (*(b_ptr++)==' '){
		n_ptr=name;
		while((*b_ptr!=')') && (*b_ptr!=' '))
		    *n_ptr++=*b_ptr++;
		*n_ptr=0;
		if (*b_ptr==' ')
		    while(*b_ptr!=')')
			b_ptr++;
		if (strcmp(name,team_name)==0)
		    dum_p=&mplayer[mp_num++];
		else
		    dum_p=&oplayer[op_num++];
		b_ptr=get_para(dum_p,b_ptr+2);
		if (dum_p->d[0]<2.0){ /* collision check */
		    if ((dum_p->d[1]<60.0) && (dum_p->d[1]>0.0))
			collision_flag=-1;
		    else if ((dum_p->d[1]>-60.0) && (dum_p->d[1]<0.0))
			collision_flag=1;
		}
	    } else{
		b_ptr=get_para(&dummy,b_ptr+2);
	    }
	    break;

	  case 'g': /* goal */
	    b_ptr+=5;
	    if (*b_ptr==side)
		i=0;
	    else
		i=1;
	    b_ptr=get_para(&goal[i],b_ptr+3);		
	    break;

	  case 'b': case 'B': /* ball */
	    b_ptr=get_para(&ball,b_ptr+6);
	    b_flag=1;
	    break;

	  case 'f': /* flag */
	    b_ptr+=5;
	    i=1;
	    while(1){
		switch(*b_ptr){
		  case 'p':
		    i+=3; break;
		  case 'l':
		    if (side=='l') i+=1;
       		    else i+=6;
		    break;
		  case 'r':
		    if (side=='l') i+=6;
		    else i+=1;
		    break;
		  case 't':
		    if (side!='l')
			i+=1;
		    break;
		  case 'b':
		    if (side=='l')
			i+=1;
		    break;
		  case 'c':
		    i-=1; break;
		}
		b_ptr+=2;
		if (*b_ptr==' ')
		    break;
	    }
	    b_ptr=get_para(&flag[i],b_ptr+1);
	    break;
	  case 'G': case 'F': case 'P':
	    i=0;
	    while (i<2){
		b_ptr++;
		if (*b_ptr==')')
		    i++;
	    }
	    b_ptr++;
	    break;
	}
	if (*b_ptr==')')
	    break;
	else
	    b_ptr+=3;
    }
}
	
int hear(char *buf){
    int  t_code,t;
    char dir_str[50],mes[50];
    double x,y;
    
    sscanf(buf,"(hear %d %s %s)",&t,dir_str,mes);
    if (strcmp(mes,team_name)==0){
	sscanf(buf,"(hear %d %s %s %d %lf %lf)",&t,dir_str,mes,&t_code,&bx,&by);
	if (t_code>=time_stamp){
	    time_stamp=t_code;
	    if ((!b_flag) && (strcmp(dir_str,"self")!=0))
		h_flag=1;
	} /* else
	    printf("mimic message \n  %s!!\n",buf);*/
    } else{
	if (strcmp("self",dir_str)==0) return -1;
	if (strcmp("referee",dir_str)!=0) return -1;
	if (strncmp("kick_off_",mes,9)==0) return 1;
    }
    return -1;
}
	

void message_loop(FILE* fpin, FILE* fpout, Socket sock)
{
    fd_set	readfds ;
    int		in, max_fd, n ;
    char	buf[MAXMESG];
    char	end_mes[]="quit";

    in = fileno(fpin) ;
    while(1){
	FD_ZERO(&readfds) ;
	FD_SET(in, &readfds) ;
	FD_SET(sock.socketfd, &readfds) ;

	max_fd = ((in > sock.socketfd) ? in : sock.socketfd) + 1 ;
	if(select(max_fd, &readfds, 0, 0, 0) == -1){
	    perror("select") ;
	    break ;
	}

	if(FD_ISSET(in, &readfds)){
	    fgets(buf, MAXMESG, fpin) ;
	    	if (strncmp(end_mes,buf,4)==0) break;
	}

	if(FD_ISSET(sock.socketfd, &readfds)){
	    n = receive_message(buf, MAXMESG, &sock) ;
	    if(n == -1)
		break ;
	    else if(n > 0){
	    	if (buf[1]=='s'){
		    see(buf);
		    s_flag=1;		    
	    	} else
		    hear(buf);
		fflush(stdout) ;
	    }			
	}
	if (think()){
	    s_flag=0;
	    h_flag=0;
	    b_flag=0;
	    collision_flag=0;
	}
    }
}

/*
 * socket  close
 *
 *  :
 * sock : socket
 * 
 */


/* for test */
#ifdef TEST
void main(int argc, char **argv)
{
    char *server;
    int port=6000;


    if(argc == 3) {
	server = argv[1] ;
	port = atoi(argv[2]) ;
    } else if (argc == 2) {
	server = argv[1] ;
	port = 6000 ;
    } else {
	server = "localhost" ;
	port = 6000 ;
    }
    
    sock = init_connection(server,port) ;
    
    if(sock.socketfd == -1)
	exit(1) ;
    
    if (init_condition(team_name)!=-1)
	    message_loop(stdin, stdout, sock) ;

    close_connection(sock) ;
}
#endif /* TEST */

