/*
 *  Soccer Client Program header
 *    Ogalets the fifth
 *      presented by Ogawara
 */

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h>
#include <errno.h>

#define DEFAULT_PORT_NUMBER	6000
#define MAXMESG			1024

#ifdef MEMSET
#define bzero(a, b) memset(a, 0, b)
#endif

typedef struct socket{
    int			socketfd  ;
    struct sockaddr_in	serv_addr ;
}Socket ;

#define  MAX_TIME_COUNTER 1000
#define  PI (3.1415927)
#define  get_dist(x1,y1,x2,y2) (sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)))
#define  random_num(num) (random()%num)
#define  abs_d(d) ((d>0.0) ? (d) : (-d))

struct relative_address{
    int  count;
    double dist;
    int  dir,vdir;
    double d[4]; /*0... dist,1... dir, 2... dist_chg,3... dir_chg */
};

struct sequence_list{
    int  count;
    double dist[4],dir[4];
};

Socket init_connection(char* host, int port) ;
int    send_message(char* buf, Socket sock) ;
int    receive_message(char *buf, int size, Socket *sock) ;
void   close_connection(Socket sock) ;
double get_angle(double dx,double dy);
int    get_my_posi(void);		/*when lost return -1,else return 0*/
void   kick(int pow,double dir);
void   dash(int pow);
void   turn(double angle);
char   *get_para(struct relative_address *st,char *buf);
int    init_condition(char *name);	/*-1...error*/
